- [Creating issues](#creating-issues)
- [Pull request](#pull-request)

## Creating issues

- To file a bug, please describe the steps to reproduce the issue and include your version of WayLyrics. Also, please grab logs from WayLyrics by setting `RUST_LOG=waylyrics=trace`.
- If you want to propose a new feature, feel free to describe your idea and the motivation behind it.
- We'd like to accept issues in English or Chinese to accommodate the majority of users for easier communication.

## Pull request

There are numerous of suggestions for pull request of Waylyrics:

1. Apply `cargo clippy --fix` before committing
2. Squash your commits if your pull request was about single bug/feature/enhancement
3. In addition, if you have multiple unrelated features to submit, please try to open separate pull requests for each feature.
4. Prefer [Conventional Commit](https://www.conventionalcommits.org/)
